{
  CellSource 1.0
  Copyright (C) 1996-2002 by Berg
  All rights reserved.

  $id:CustomCellSource.pas
}

unit CustomCellSource;

interface

uses
  Windows, Messages, SysUtils, Classes,
  GridView;

type
  TCustomCellSource = class(TComponent)
  private
    FGrid: TGridView;
    FActive: Boolean;
    procedure SetGrid(const Value: TGridView);
    procedure SetActive(const Value: Boolean);
  public
    function Execute: Boolean; virtual;
    function IsReady: Boolean; virtual; abstract;
    function Update: Boolean; virtual;
    constructor Create(AOwner: TComponent); override;
  published
    property Active: Boolean read FActive write SetActive;
    property Grid: TGridView read FGrid write SetGrid;
  end;

implementation

{ TCustomCellSource }

constructor TCustomCellSource.Create(AOwner: TComponent);
begin
  inherited;
  FGrid := nil;
end;

procedure TCustomCellSource.SetActive(const Value: Boolean);
begin
  if FActive = Value then Exit;
  FActive := Value;
  if Assigned(Grid) then if Value = True then Execute else Grid.ClearRows;
end;

procedure TCustomCellSource.SetGrid(const Value: TGridView);
begin
  FGrid := Value;
end;

function TCustomCellSource.Execute: Boolean;
begin
  Result := IsReady;
end;

function TCustomCellSource.Update: Boolean;
begin
  Result := IsReady;
end;

end.
